﻿/* This macro retuns a list of variables contained in the */
/* in the specified dataset. */
/* The use of DOSUBL mimics a PROC FCMP function */  
%MACRO ExpandVarList(data=_LAST_, var=_ALL_);
	%if %upcase(%superq(data)) = _LAST_ %then
		%let data = &SYSLAST;
	%let rc = %sysfunc(dosubl(%str(
		proc transpose data=&DATA(obs=0) out=ExpandVarList_temp;
		var &VAR;
		run;
		proc sql noprint;
		select _name_ into :temp_varnames separated by ' '
		from ExpandVarList_temp
		;
		drop table ExpandVarList_temp;
		quit;
		)));
	&temp_varnames
%MEND ExpandVarList;

/* Look at the output of the macro */
%put %ExpandVarList(data=sashelp.class);

/* Use it as a macro"function" */
data newclass(keep=newvar1 %ExpandVarList(data=sashelp.class));
	newvar1=1;
	tempvar=0;
	set sashelp.class;
run;

proc print data=work.newclass;
run;